#!/usr/bin/env python

from qt import *
import qtxmldom

class Factory:
    def __init__(self, ui_filename):
        self.ui = qtxmldom.parse(ui_filename)

    def findWidget(self, widget_class, name):
        for widget in self.ui.getElementsByTagName("widget"):
            if widget.getAttribute("class") == widget_class:
                for property in widget.getElementsByTagName("property"):
                    if property.getAttribute("name") == "name":
                        for cstring in property.getElementsByTagName("cstring"):
                            cstring.normalize()
                            found_name = cstring.childNodes[0].nodeValue
                            if found_name == name:
                                return widget
        return None

# vim: tabstop=4 expandtab shiftwidth=4
